Subject: bug#42138: 26.3; Incompatibility between font-lock-add-keywords and enriched.el

From: Eli Zaretskii <[email-masked]>
Date: Mon, 20 Jul 2020 17:40:16 +0300

> Date: Mon, 20 Jul 2020 08:59:31 +0200
> From: Vasilij Schneidermann <[email-masked]>
> Cc: [email-masked]
> 
> > I think enriched-mode, like any other mode that puts its own faces on
> > chunks of text by means other than font-lock, is fundamentally
> > incompatible with font-lock.  It's basically the same problem as if
> > you tried to use put-text-property in *scratch* to put some face
> > property on some text in the buffer: the face won't show until you
> > turn off font-lock.  That's because the first thing font-lock does is
> > wipe out all the faces in the buffer.
> 
> Thanks for the clarification.  This doesn't really help me though, I want to
> adjust my existing font-lock using code so that it detects when it would wipe
> out said text properties enriched-mode set up.  It doesn't appear to be
> sufficient to just check whether `font-lock-mode` is non-nil, if I do that
> inside the example enriched.txt file, it's set to `t` for some reason.  Again,
> what would the correct check be here?

I think you want to look at font-lock-defaults.

> > Any way that uses put-text-property, add-text-properties, etc. without
> > using font-lock will do.  You can even try that manually via the
> > facemenu-set-* commands (or via the Edit->Text Properties menu from
> > the menu bar).
> 
> Hm, I've done that for non-font-lock scenarios before, but in this case I
> really need font-lock's ability to search for strings and apply fontification
> to them, so this isn't really an option.  Looking for other examples in the
> Emacs sources I've found uses of `jit-lock-register`.

Ah, I guess I  misunderstood what kind of solutions you are looking
for, sorry.

If you want to keep font-lock in effect, then indeed jit-lock-register
is one feature to look at.  But there are two others:
font-lock-extra-managed-props and the font-lock-face property.  I hope
one of these will allow you to come up with a solution.